var gulp = require("gulp");
var babel = require("gulp-babel");
var sourcemaps = require("gulp-sourcemaps");
var del = require('del');
var TaskBuilder = require('gulp-task-builder');

var es6Task = TaskBuilder.newTask()
    .name("es6")
    .src(["./src/**/*.js"])
    .dest("./out")
    .process(function(gulpTask) {
        return gulpTask
            .pipe(sourcemaps.init())
            .pipe(babel())
            .pipe(sourcemaps.write("."));
    })
    .build();

var viewsTask = TaskBuilder.newTask()
    .name("views")
    .src(["./src/views/**/*.hbs"])
    .dest("./out/views")
    .build();

var publicTask = TaskBuilder.newTask()
    .name("public")
    .src(["./src/public/**/*"])
    .dest("./out/public")
    .build();

TaskBuilder.newTask()
    .name("default")
    .prerequisiteTask(es6Task)
    .prerequisiteTask(viewsTask)
    .prerequisiteTask(publicTask)
    .includeWatchers(true)
    .build();

TaskBuilder.newTask()
    .name("docker")
    .prerequisiteTask(es6Task)
    .prerequisiteTask(viewsTask)
    .prerequisiteTask(publicTask)
    .build();

gulp.task('clean', function(cb) {
    del(['out'], cb);
});

